// ExtNoteShape.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ExtNoteShape.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CExtNoteShape Class
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL(CExtNoteShape, CFORectShape, 0)
CExtNoteShape::CExtNoteShape()
{
	SetType(EXT_NOTE_SHAPE);
	SetPolyObject(FALSE);
	SetRotateProtect(TRUE);

	ShowFontProp(TRUE);
//	SetNullPen(TRUE);
	SetPointSize(10);
	m_bShowLabelAtFirst = TRUE;
	SetMultiLine(TRUE);

	SetWeight(700);
}

CExtNoteShape::CExtNoteShape(const CExtNoteShape& src)
{
	*this = src;
}

CExtNoteShape::~CExtNoteShape()
{

}

/////////////////////////////////////////////////////////////////////////////
// CExtNoteShape diagnostics

#ifdef _DEBUG
void CExtNoteShape::AssertValid() const
{
	CFORectShape::AssertValid();
}

void CExtNoteShape::Dump(CDumpContext& dc) const
{
	CFORectShape::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void CExtNoteShape::Create(CRect &rcPos,CString strCaption)
{
	CFORectShape::Create(rcPos,strCaption);

	// FODO: Add your own code here.

}

void CExtNoteShape::Serialize(CArchive& ar)
{
	CFORectShape::Serialize(ar);
	if(ar.IsStoring())
	{
		//FODO:Add your own code here.

	}
	else
	{
		//FODO:Add your own code here.

	}
}

/////////////////////////////////////////////////////////////////////////////
// CPrintBaseJob serialization
CFile* CExtNoteShape::GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,
								 CFileException* pError)
{
	CMirrorFile* pFile = new CMirrorFile;
	ASSERT(pFile != NULL);
	if (!pFile->Open(lpszFileName, nOpenFlags, pError))
	{
		delete pFile;
		pFile = NULL;
	}
	return pFile;
}

void CExtNoteShape::ReleaseFile(CFile* pFile, BOOL bAbort)
{
	ASSERT_KINDOF(CFile, pFile);
	if (bAbort)
		pFile->Abort(); // will not throw an exception
	else
		pFile->Close();
	delete pFile;
}

BOOL CExtNoteShape::OpenDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = GetFile(lpszPathName,
		CFile::modeRead|CFile::shareDenyWrite, &fe);
	if (pFile == NULL)
	{
		return FALSE;
	}
	
	CArchive loadArchive(pFile, CArchive::load | CArchive::bNoFlushOnDelete);
	loadArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		if (pFile->GetLength() != 0)
			Serialize(loadArchive);     // load me
		loadArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;
}

BOOL CExtNoteShape::SaveDocument(LPCTSTR lpszPathName)
{
	
	CFileException fe;
	CFile* pFile = NULL;
	pFile = GetFile(lpszPathName, CFile::modeCreate |
		CFile::modeReadWrite | CFile::shareExclusive, &fe);
	
	if (pFile == NULL)
	{
		
		return FALSE;
	}
	
	CArchive saveArchive(pFile, CArchive::store | CArchive::bNoFlushOnDelete);
	saveArchive.m_bForceFlat = FALSE;
	TRY
	{
		CWaitCursor wait;
		Serialize(saveArchive);     // save me
		saveArchive.Close();
		ReleaseFile(pFile, FALSE);
	}
	CATCH_ALL(e)
	{
		ReleaseFile(pFile, TRUE);
		
		return FALSE;
	}
	END_CATCH_ALL
		
		
		return TRUE;        // success
}

CExtNoteShape& CExtNoteShape::operator=(const CExtNoteShape& src)
{
	(*(CFORectShape*)this) = src;
	return (*this);
}

CFODrawShape* CExtNoteShape::Copy() const
{
	return (new CExtNoteShape(*this));
}

void CExtNoteShape::PrepareDC(CDC* pDC)
{
	CFORectShape::PrepareDC(pDC);

	//FODO:Add your own code below.
	
}

void CExtNoteShape::OnDrawTrackCustom(CDC *pDC)
{
	CFORectShape::OnDrawTrackCustom(pDC);

	// Add your own code here.

}

void CExtNoteShape::OnDrawShadow(CDC *pDC)
{
	CFORectShape::OnDrawShadow(pDC);
	
	//FODO:Add your own code below.
	
}

void CExtNoteShape::OnDrawFlat(CDC *pDC)
{
	CFODrawShape::OnDrawFlat(pDC);

	FOPRect rect = GetDrawRect();
	int cutoff = 8;

	POINT pts[ 5 ];

	pts[ 0 ].x = rect.left;
	pts[ 0 ].y = rect.top;

	pts[ 1 ].x = rect.right - cutoff;
	pts[ 1 ].y = rect.top;

	pts[ 2 ].x = rect.right;
	pts[ 2 ].y = rect.top + cutoff;

	pts[ 3 ].x = rect.right;
	pts[ 3 ].y = rect.bottom;

	pts[ 4 ].x = rect.left;
	pts[ 4 ].y = rect.bottom;

	pDC->Polygon( pts, 5 );

	pDC->MoveTo( rect.right - cutoff, rect.top );
	pDC->LineTo( rect.right - cutoff, rect.top + cutoff );
	pDC->LineTo( rect.right, rect.top + cutoff );
}

void CExtNoteShape::OnDraw3d(CDC *pDC)
{
	CFODrawShape::OnDraw3d(pDC);

	FOPRect rect = GetDrawRect();
	int cutoff = 8;

	POINT pts[ 5 ];

	pts[ 0 ].x = rect.left;
	pts[ 0 ].y = rect.top;

	pts[ 1 ].x = rect.right - cutoff;
	pts[ 1 ].y = rect.top;

	pts[ 2 ].x = rect.right;
	pts[ 2 ].y = rect.top + cutoff;

	pts[ 3 ].x = rect.right;
	pts[ 3 ].y = rect.bottom;

	pts[ 4 ].x = rect.left;
	pts[ 4 ].y = rect.bottom;

	pDC->Polygon( pts, 5 );

	pDC->MoveTo( rect.right - cutoff, rect.top );
	pDC->LineTo( rect.right - cutoff, rect.top + cutoff );
	pDC->LineTo( rect.right, rect.top + cutoff );

}

void CExtNoteShape::ClearDC(CDC* pDC)
{
	CFORectShape::ClearDC(pDC);

	//FODO:Add your own code below.

}

void CExtNoteShape::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CFORectShape::OnLButtonDown(nFlags,point);
	
	//FODO:Add your own code below.

}

void CExtNoteShape::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CFORectShape::OnLButtonUp(nFlags,point);

	//FODO:Add your own code below.

}

void CExtNoteShape::GeometryUpdated(CFOArea* pRgn)
{
	CFORectShape::GeometryUpdated(pRgn);

	//FODO:Add your own code below.

}
